<?php

define('SKIP_KOHANA', true);
require('/opt/monitor/op5/ninja/index.php');

$conf_info = '';
$sys_cmds = '';
$fd = fopen('/opt/monitor/etc/cgi.cfg', 'r');
while (($row = fgets($fd)) !== false) {
	if (strpos($row, 'authorized_for_system_commands') !== false)
		$sys_cmds = $row;
	else if (strpos($row, 'authorized_for_configuration_information') !== false)
		$conf_info = $row;
}
fclose($fd);

require_once('op5/config.php');
$userfile = "auth_users";
$groupfile = "auth_groups";

$config = Op5Config::instance();

$user_array = $config->getConfig($userfile);
$correct_group_array = $config->getConfig($groupfile);
$group_array = array();
$role_disallow = array(); /**< Holds all rules that will be erased in case a no-access rule has been set for a role */

$query = "SELECT count(*) FROM information_schema.tables WHERE table_schema = 'nacoma' AND table_name = 'role'";
$result = nacoma_db::exec_query($query);
$rows = $result->fetchAll(PDO::FETCH_NUM);
if (!$rows[0][0])
	exit(0);

$query = "SELECT role_name FROM role";
$result = nacoma_db::exec_query($query);
while ($res = $result->fetch(PDO::FETCH_ASSOC)) {
	$group_array[$res['role_name']] = array(
		'host' => array('view_all' => true, 'edit_all' => true, 'add_delete' => true),
		'host_template' => array('view_all' => true, 'edit_all' => true, 'add_delete' => true),
		'hostgroup' => array('view_all' => true, 'edit_all' => true, 'add_delete' => true),
		'service' => array('view_all' => true, 'edit_all' => true, 'add_delete' => true),
		'service_template' => array('view_all' => true, 'edit_all' => true, 'add_delete' => true),
		'servicegroup' => array('view_all' => true, 'edit_all' => true, 'add_delete' => true),
		'contact' => array('view_all' => true, 'edit_all' => true, 'add_delete' => true),
		'contact_template' => array('view_all' => true, 'edit_all' => true, 'add_delete' => true),
		'contactgroup' => array('view_all' => true, 'edit_all' => true, 'add_delete' => true),
		'command' => array('view_all' => true, 'edit_all' => true, 'add_delete' => true),
		'timeperiod' => array('view_all' => true, 'edit_all' => true, 'add_delete' => true),
		'hostdependency' => array('view_all' => true, 'edit_all' => true, 'add_delete' => true),
		'hostescalation' => array('view_all' => true, 'edit_all' => true, 'add_delete' => true),
		'servicedependency' => array('view_all' => true, 'edit_all' => true, 'add_delete' => true),
		'serviceescalation' => array('view_all' => true, 'edit_all' => true, 'add_delete' => true),
		'FILE' => true,
		'pnp' => true,
		'access_rights' => true,
		'export' => true);
	$role_disallow[$res['role_name']] = array(
		'host' => false,
		'host_template' => false,
		'hostgroup' => false,
		'service' => false,
		'service_template' => false,
		'servicegroup' => false,
		'contact' => false,
		'contact_template' => false,
		'contactgroup' => false,
		'command' => false,
		'timeperiod' => false,
		'hostdependency' => false,
		'hostescalation' => false,
		'servicedependency' => false,
		'serviceescalation' => false,
		'FILE' => false,
		'pnp' => false,
		'access_rights' => false,
		'export' => false);
}
unset($result);

$query = "SELECT a.role_name AS name, b.object_type AS type, b.rule AS rule 
			FROM role AS a, role_permissions AS b 
			WHERE a.id = b.role_id 
			ORDER BY b.role_id";
$result = nacoma_db::exec_query($query);
while ($res = $result->fetch(PDO::FETCH_ASSOC)) {
	switch($res['type']) {
		# objects with "by-contact-access"
		case 'host':
		case 'host_template':
		case 'hostgroup':
		case 'service':
		case 'service_template':
		case 'servicegroup':
		case 'contact':
		case 'contact_template':
		case 'contactgroup':
			switch($res['rule']) {
				case 'by-contact-access':
					$group_array[$res['name']][$res['type']]['edit_contact'] = true;
					$group_array[$res['name']][$res['type']]['view_contact'] = true;
					$role_disallow[$res['name']][$res['type']]['view_all'] = true;
					$role_disallow[$res['name']][$res['type']]['edit_all'] = true;
					break;
				default:
					break;
			}
			/* fallthrough */
		# "regular" nagios objects
		case 'command':
		case 'timeperiod':
		case 'hostdependency':
		case 'hostescalation':
		case 'servicedependency':
		case 'serviceescalation':
			switch($res['rule']) {
				case 'no-create':
					$role_disallow[$res['name']][$res['type']]['add_delete'] = true;
					break;
				case 'no-edit':
					$role_disallow[$res['name']][$res['type']]['edit_all'] = true;
					$role_disallow[$res['name']][$res['type']]['edit_contact'] = true;
					break;
				case 'no-access':
					$role_disallow[$res['name']][$res['type']]['view_all'] = true;
					$role_disallow[$res['name']][$res['type']]['edit_all'] = true;
					$role_disallow[$res['name']][$res['type']]['view_contact'] = true;
					$role_disallow[$res['name']][$res['type']]['edit_contact'] = true;
					$role_disallow[$res['name']][$res['type']]['add_delete'] = true;
					break;
				case 'allow':
					break;
				default:
					break;
			}
			break;
		# "thin" special cases
		case 'FILE':
		case 'pnp':
		case 'access_rights':
		case 'export':
			switch($res['rule']) {
				case 'allow':
					break;
				case 'no-access':
					$role_disallow[$res['name']][$res['type']] = true;
					break;
			}
			break;
		default:
			break;
	}
}

foreach ($group_array as $groupname => $rules) {
	foreach ($role_disallow[$groupname] as $type => $rule) {
		if ($rule === true)
			$rules[$type] = false;
		if (is_array($rule)) {
			foreach ($rule as $key => $_)
				unset($rules[$type][$key]);
		}
	}

	$correct_group_array[$groupname] = isset($correct_group_array[$groupname]) ? $correct_group_array[$groupname] : array();
	foreach ($rules as $type => $rule) {
		if ($rule === true) {
			$correct_group_array[$groupname][] = $type;
		}
		else if (is_array($rule)) {
			foreach ($rule as $ruletype => $_) {
				$correct_group_array[$groupname][] = $type.'_'.$ruletype;
			}
		}
	}
	$correct_group_array[$groupname] = array_values(array_unique($correct_group_array[$groupname]));
}

$query = "SELECT a.username AS username, b.role_name AS role_name
			FROM username_role AS a, role AS b
			WHERE a.role = b.id";
$result = nacoma_db::exec_query($query);
while ($res = $result->fetch(PDO::FETCH_ASSOC)) {
	if (!isset($user_array[$res['username']]))
		$user_array[$res['username']] = array('username' => $res['username']);
	$user_array[$res['username']]['groups'][] = $res['role_name'];
	$user_array[$res['username']]['has_been_modified'] = 1;
}

# users were always included in the default role if nothing else was specified,
# so keep this weird-ass behaviour around.
foreach ($user_array as $username => $user) {
	if (isset($user['has_been_modified'])) {
		unset($user_array[$username]['has_been_modified']);
	}
	else if(preg_match('/[=,]'.$username.'(,|$)/', $conf_info) && preg_match('/[=,]'.$username.'(,|$)/', $sys_cmds)) {
		$user_array[$username]['groups'][] = 'default';
	}
	if (isset($user_array[$username]['groups']))
		$user_array[$username]['groups'] = array_unique($user_array[$username]['groups']);
}

//Create a timestamped copy of the config
$now = time();
@exec('cp /etc/op5/auth_users.yml /etc/op5/auth_users_' . $now . '.yml');
@exec('cp /etc/op5/auth_groups.yml /etc/op5/auth_groups_' . $now . '.yml');

//Set the config using Op5Config class
$config->setconfig($userfile, $user_array);
$config->setconfig($groupfile, $correct_group_array);

$query = "DROP TABLE username_role, role, role_permissions";
$result = nacoma_db::exec_query($query);
