<?php


function clone_ask_var($text, $vname, $ar_name, $checked = 'checked', $img = false)
{
	echo "<tr>";
	echo "<td class=\"HelpList\"><input type='checkbox' name='{$ar_name}[$vname]' checked='$checked' /></td>\n";
	echo "<td class=\"HelpList\" colspan=\"2\">\n";
	if ($img)
	  echo "<img src=\"images/icons/arrow-tree.gif\" alt=\"\" />&nbsp; \n";
	echo "$text</td>\n";
	echo "</tr>\n";
}


function populate_sub_object_list($obj){
	if ($obj->type !== 'service' && $obj->type !== 'host')
	  return;

	# set the link variable suffix
	$lvar = $obj->type === 'host' ? 'host_name' : 'service';

	$obj->sub_objs[$obj->type . 'escalation'] =
	  $obj->get_sub_object_ids($obj->type . "escalation", $lvar);
	$obj->sub_objs[$obj->type . 'dependency'] =
	  $obj->get_sub_object_ids($obj->type . "dependency", "dependent_$lvar");

	foreach ($obj->sub_objs as $type => $ary)
	  if (empty($ary))
		unset($obj->sub_objs[$type]);
}


function host_clone_create_service_list($obj)
{
	$ary = $obj->get_sub_object_ids('service', 'host_name');
	if (!$ary) {
		echo "<tr><td>Host {$obj->obj['host_name']} has no service associated</td></tr>\n";
		return;
	}

	foreach ($ary as $id) {
		$srv = new service_nacoma_Model($id);
		populate_sub_object_list($srv);
		$srv_list[] = $srv;
	}

	$i = 0;
	foreach ($srv_list as $srv) {
		$i++;
		$ar_name = 'sub_obj[service][' . $srv->id . ']';
		$id = preg_replace('/[^a-zA-Z0-9]/', '_', $ar_name);
		echo "<tr>";
		echo "  <td class=\"HelpList\" style=\"width: 10px; text-align: center\"><input id='$id' type='checkbox' name='{$ar_name}[service]'" .
		  " checked=\"checked\" /></td>";
		echo "  <td class=\"VarList\" colspan=\"2\" style= \"width: 99%;border-right: 1px solid #cdcddc\"><label for='$id'>" . $srv->obj['service_description'] . "</label></td>\n";
		 echo "</tr>\n";

		ask_about_sub_objects($srv, $ar_name, true);
	}
}

function ask_about_sub_objects($obj, $ar_name = 'sub_obj', $img = false)
{
	if (!empty($obj->sub_objs[$obj->type . 'escalation']))
	  clone_ask_var('Escalations', $obj->type . 'escalation', $ar_name, true, $img);
	if (!empty($obj->sub_objs[$obj->type . 'dependency']))
	  clone_ask_var('Dependencies', $obj->type . 'dependency', $ar_name, false, $img);
}

function ask_host_clone_questions($obj)
{
	populate_sub_object_list($obj);
	if (!empty($obj->sub_objs))
	  echo '<tr class="header"><td colspan="3">Settings for host</td></tr>';
	ask_about_sub_objects($obj);

	echo '<tr class="header"><td colspan="3">Settings for services</td></tr>';
	host_clone_create_service_list($obj);
}

function clone_slave_object($obj)
{
	global $input, $page;
	$class_name = $obj->type . '_nacoma_Model';

	$errors = array();
	$selection = $input->selection;
	if (empty($selection)) {
		echo "No objects selected to clone to.\n";
		clone_step_1($obj);
	}

	$clones = 0;
	foreach ($selection as $type => $typeselection) {
		foreach ($typeselection as $master_id) {
			$nobj = $obj->clone_object();
			$nobj->set_master_object_type($type);
			$nobj->set_master_object_id($master_id);
			if ($nobj->save_object() === false) {
				$errors[] = $nobj->validation_error_list;
			} else {
				$clones++;
			}
		}
	}
	if (!empty($errors)) {
		echo "<pre>\n"; print_r($errors); echo "</pre>\n";
	}
	echo "Created $clones " . $obj->type . " objects<br />\n";
	$page->html_end();
}

function clone_step_1($obj)
{
	global $page;

	$denom = $obj->denormalize();

	# hosts have 3 steps, services have 2 and everything else has 1
	$steps = $obj->type === 'host' ? 3 : 1 + intval($obj->type === 'service');
	echo "<h2>Clone $obj->type";
	if ($steps > 1)
		echo " step 1 / $steps";
	echo "</h2>";
	echo "<p><img src=\"images/icons/arrow.gif\" alt=\"\" class=\"show\" /> &nbsp;<a href='edit.php?obj_type=$obj->type&amp;obj_id=$obj->id' class=\"arrow\">Edit this object</a></p>\n";
	echo "<div id=\"object-table\">";
	echo '<table class="max zebra">';

	switch ($obj->type) {
	 case 'host':
		echo '<tr class="header"><td colspan="3">';
		echo "Clone host '" . $obj->obj['host_name'] . "'</td></tr>";
		echo "<tr><td class=\"VarList\" colspan=\"3\" style=\"border-right: 1px solid #cdcdcd\"><label for='clone_targets'>Number of copies to make:</label> <input type='text' value='1' size='4' name='clone_targets' id='clone_targets'></tr>\n";
		ask_host_clone_questions($obj);
		break;

	 case 'service':
		foreach ($obj->master_obj_candidates as $obj_type => $_) {
			echo '<tr class="header"><td colspan="3">';
			echo "Select $obj_type to clone {$obj->get_object_name()} to</td></tr>\n\n";
			echo '<tr><td class="VarList style="border-right: 1px solid #cdcdcd">';
			if ($obj_type === $obj->master_obj_type)
				$page->make_multi_obj_selection($obj_type, $denom[$obj->master_obj_identifier]);
			else
				$page->make_multi_obj_selection($obj_type, false);
			echo '</td></tr>';
		}
		echo '</tr></td><tr><td class="VarList">';
		echo "<table class='max zebra'>\n";
		echo '<tr class="header"><td colspan="3">Settings for service</td></tr>';
		populate_sub_object_list($obj);
		ask_about_sub_objects($obj);
		break;

	 default:
		foreach ($obj->master_obj_candidates as $obj_type => $_) {
			echo '<tr class="header"><td colspan="3">';
			echo "Select $obj_type to clone {$obj->get_object_name()} to</td></tr>\n\n";
			echo '<tr><td class="VarList style="border-right: 1px solid #cdcdcd">';
			if ($obj_type === $obj->master_obj_type)
				$page->make_multi_obj_selection($obj_type, $denom[$obj->master_obj_identifier]);
			else
				$page->make_multi_obj_selection($obj_type, false);
			echo '</td></tr>';
		}
	}

	echo "</table></div>\n";
	$page->submit_button('Clone');
}

# cloning services is complete after this step, although we may have to
# ask for confirmation during this step, and receive it in the next
function service_clone_step_2($obj, $sub_objs)
{
	global $input, $page;

	if (empty($input->selection)) {
		echo "No hosts or hostgroups selected<br />\n";
		$page->html_end();
	}

	$obj->sub_objects = load_sub_objects($obj, $sub_objs);

	if (!empty($input->selection)) {
		foreach ($input->selection as $type => $typeselection) {
			if (empty($typeselection))
				continue;
			$obj->set_master_object_type($type);
			foreach ($typeselection as $id => $discard)
				save_object_chain($obj, $id);
		}
	}

	echo top_bar_nacoma_Model::add_unsaved_warning();
}

# This is where it gets interesting. We know what we're supposed to clone,
# but we'll still need to identify the unique fields and make sure the
# user gets to enter them in a nice fashion.
function host_clone_step_2($obj, $clone_targets, $vars_to_clone, $sub_objs_to_clone)
{
	global $page;

	function host_clone_ask_detail($i, $det_var, $det_val = '')
	{
		echo "<tr>\n  <td class=\"VarList\"><label for='clone_detail[$i][$det_var]'>$det_var</label></td>\n" .
		  "  <td style=\"border-right: 1px solid #cdcddc\">" .
		  "<input type='text' value='$det_val' id='clone_detail[$i][$det_var]' name='clone_detail[$i][$det_var]' class=\"large\" />\n" .
		  "  </td>\n</tr>\n";
	}

	if (is_array($vars_to_clone)) {
		foreach ($vars_to_clone as $k => $v) {
			$page->hidden_var("vars_to_clone[$k]", $v);
		}
	}

	if (is_array($sub_objs_to_clone))
		$page->hidden_var_array('sub_obj', $sub_objs_to_clone);

	# ask for new host_names, addresses and aliases.
	# host_name and address are by default empty, while alias
	# holds the value of the pre-carbon clone.

	$obj_type = isset($_GET['obj_type']) ? $_GET['obj_type'] : '';
	echo '<h2>Clone '.$obj_type.' step 2 / 3</h2>';
	echo '</div></div><div id="object-table">';

	for ($i = 0; $i < $clone_targets; $i++) {
		echo "<table class=\"max zebra\">\n";
		echo '<tr class="header"><td colspan="2">Clone # '.($i+1).'</td></tr>';
		host_clone_ask_detail($i, 'host_name', '');
		host_clone_ask_detail($i, 'alias', isset($obj->obj['alias']) ? $obj->obj['alias'] : '');
		host_clone_ask_detail($i, 'address', '');
	}

	echo '<tr><td colspan="2" class="button" style="border-top: 1px solid #cdcddc; padding-top: 7px;">';
	$page->submit_button('Create host clones');
	echo "</td></tr></table><br />\n";
}

function load_sub_objects($orig_obj, $sub_obj)
{
	$srv_list = array();

	if (empty($sub_obj))
	  return;

	if (!empty($sub_obj['service'])) {
		$srv_list = $sub_obj['service'];
		unset($sub_obj['service']);
	}

	if ($orig_obj->type === 'host')
	  $slave_link_var = 'host_name';
	else
	  $slave_link_var = 'service';

	foreach ($sub_obj as $obj_type => $on_off) {
		if ($on_off !== 'on')
		  continue;

		$class_name = $obj_type . '_nacoma_Model';

		switch ($obj_type) {
		 case 'servicedependency': case 'hostdependency':
			$slink_prefix = 'dependent_';
			break;
		 default:
			$slink_prefix = '';
		}

		$id_list = $orig_obj->get_sub_object_ids($obj_type, $slink_prefix . $slave_link_var);
		if ($id_list) foreach ($id_list as $id) {
			$nobj = new $class_name($id);
			$orig_obj->sub_objects[] = $nobj;
		}
	}

	foreach ($srv_list as $id => $ary) {
		if (!isset($ary['service']) || $ary['service'] !== 'on')
		  continue;

		unset($ary['service']);
		$nobj = new service_nacoma_Model($id);
		load_sub_objects($nobj, $ary);
		$orig_obj->sub_objects[] = $nobj;
	}

	if (!empty($orig_obj->sub_objects))
	  return $orig_obj->sub_objects;
}

/**
 * Save an object's sub-objects, setting master object id as we go.
 */
function save_object_chain($obj, $master_obj_id = false, $depth = 0, $action_name = 'cloned')
{
	global $page;

	$obj->set_master_object_id($master_obj_id);
	$obj->id = 'new';
	if (isset($obj->clone_id))
		unset($obj->clone_id);
	$result = $obj->save_object();
	if ($result !== true)
		echo "<p><img src=\"images/icons/shield-critical_16x16.png\" alt=\"\" style='margin: -1px 3px 3px 0px; float: left' />";
	else
		echo "<p><img src=\"images/icons/shield-ok_16x16.png\" alt=\"\" style='margin: -1px 3px 3px 0px; float: left' />";

	for ($i = 0; $i < $depth; $i++)
	  echo "&nbsp; &nbsp; ";

	if ($result !== true) {
		echo "Failed to save $obj->type {$obj->get_object_name()}</p>\n";
		$page->print_validation_error_table($obj);

		return false;
	}
	else {
		$name = $obj->get_object_name();
		echo "Successfully ".$action_name." <a href='edit.php?obj_type=$obj->type&obj_id=$obj->id'>" . $name . "</a></p>\n";
	}

	if (empty($obj->sub_objects))
	  return true;

	foreach ($obj->sub_objects as $o) {
		if (!save_object_chain($o, $obj->id, $depth + 1)) {
			return false;
		}
	}

	return true;
}

function host_clone_step_3($obj, $clone_detail, $sub_objs_to_clone)
{
	$srv_id = false;
	$srv_sub_obj_list = false;

	echo "<h2>Clone host step 3/3</h2>";

	# first we locate and load all the sub-objects
	# we're supposed to clone alongside the master object(s)
	$sub_objects = load_sub_objects($obj, $sub_objs_to_clone);

	# make the proper amount of master object clones
	for ($i = 0; $i < count($clone_detail); $i++) {
		$cobj = $obj->clone_object();
		foreach (array('host_name', 'address', 'alias') as $v) {
			if (isset($clone_detail[$i][$v]))
			  $cobj->obj[$v] = trim($clone_detail[$i][$v]);
		}
		if (empty($cobj->obj['host_name']) && !empty($cobj->obj['address']))
		  $cobj->obj['host_name'] = $cobj->obj['address'];
		if (empty($cobj->obj['address']) && !empty($cobj->obj['host_name']))
		  $cobj->obj['address'] = $cobj->obj['host_name'];

		$cloned_objs[] = $cobj;
	}

	$result = (bool)$cloned_objs;

	foreach ($cloned_objs as $cobj) {
		$result = $result && save_object_chain($cobj);
	}

	if ($result) {
		echo "<p>Clone host was committed successfully!</p>";
		echo top_bar_nacoma_Model::add_unsaved_warning();
	}

	return true;
}
