<?php
require_once('op5/log.php');
require_once('op5/auth/Auth.php');
require_once('op5/auth/Authorization.php');

/*
 * Copyright(C) 2003-2005, 2007 op5 AB
 * All rights reserved.
 *
 */

global $DEBUG;
$DEBUG = false;
global $IMPORTING;
$IMPORTING = false;

global $Version;
$Version = '2018.s.1-op5.1.20191004141732.el6';


global $HOME;
$HOME		= '/opt/monitor/';
global $DATADIR;
$DATADIR	= $HOME . 'op5/nacoma/data/';
global $IMPORTDIR;
$IMPORTDIR	= $HOME . 'op5/nacoma/imported/';
global $COMMENTDIR;
$COMMENTDIR = $IMPORTDIR . 'comments/';
global $HOOKDIR;
$HOOKDIR    = $HOME . 'op5/nacoma/hooks/';

global $Config;
$Config['main']		= $HOME . 'etc/nagios.cfg';
$Config['cgi']		= $HOME . 'etc/cgi.cfg';

global $SUPPORT;
$SUPPORT = "<a href='https://www.op5.com/support'>OP5 Support</a>";

global $Backup_Config_Dir;
$Backup_Config_Dir = "/tmp/nacoma-conf-backup/";

global $Supported_Object_Types;
$Supported_Object_Types =
  array('contact',
		'contactgroup',
		'hostgroup',
		'host',
		'service',
		'servicegroup',
		'timeperiod',
		'command',
		'servicedependency',
		'serviceescalation',
		'hostdependency',
		'hostescalation',
		'FILE'
		);

$show_logserver_scan = true;

define("CUSTOM_CONFIG", dirname(__FILE__)."/../custom_config.php");

# variables settable from the CUSTOM_CONFIG files
global $notouch_files;
$notouch_files = array();
global $notouch_file_prefix;
$notouch_file_prefix = false;
global $notouch_dir_prefix;
$notouch_dir_prefix = false;
if (is_file(CUSTOM_CONFIG) && is_readable(CUSTOM_CONFIG))
	require_once(CUSTOM_CONFIG);

function give_infinite_rights($username = 'superuser')
{
	set_user($username);
	$auth = Op5Auth::instance();
	$user = $auth->get_user();
	foreach (array_reduce(Op5Authorization::get_all_auth_levels(), function($a, $b) {return array_merge($a, array_keys($b));}, array()) as $value) {
		$auth_data[$value] = true;
	}
	$user->set_auth_data($auth_data);
}

/**
 * Sets the username that other functions can
 * later use to get the name of the logged-in
 * user.
 */
function set_user ($user, $groups = array()) {
	Op5Auth::instance()->force_user(
		new User_Model(array(
			"username" => $user,
			"groups" => $groups
		))
	);
}

/**
 * Retrieves the username as either set by the
 * set_user() function, or as determined by the
 * environment or insn.
 *
 * @return string username
 */
function get_user()
{
	return Op5Auth::instance()->get_user()->get_username();
}

/**
 * @return string current version number, or empty if version file cannot be found
 */
function monitor_version() {
	if(!@is_readable('/etc/op5-monitor-release')) {
		return "";
	}
	return trim(preg_replace('/^VERSION=/', null, file_get_contents('/etc/op5-monitor-release')));
}
