<?php
/*
 * Copyright(C) 2003-2005, 2007 op5 AB
 * All rights reserved
 *
 */

define('SKIP_KOHANA', true);
require_once(__DIR__.'/../ninja/index.php');

require_once('include/import.inc.php');
require_once('include/webconfig.inc.php');
require_once('classes/common_gui.php');
require_once('op5/log.php');

nacoma_objlock::die_if_locked_hard();

$access = get_nacoma_access('configuration_information');
if (!in_array(NACOMA_ACCESS_FULL_ACCESS, $access)) {
	$page->html_start("Access denied!");
	echo "<p class=\"note\">It appears as though you aren't authorized to access the configuration interface.</p>
			<p>Note that at least one of your groups must be authorized for both <strong>'configuration_information'</strong>
			and <strong>'system_commands'</strong> to be able change any configuration.</p>";
	$page->html_end();
} // html_end exists

$page->html_start();

$rights = get_rights();
# import or not?
if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'Import') {
	$rights = get_rights();
	if ((isset($rights['configuration_all'])) && isset($_REQUEST['force'])) {
		$page->run_import('Import forced');
	} else {
		revert_users_changes();
		if (isset($rights['configuration_all']))
			echo '<div class="note"><p>You might want to do a <a target="_parent" href="'.url::method('configuration', 'index', array('action' => 'Import', 'force' => 'force')).'">complete reimport</a>?</p></div>';
	}
}

$page->import_if_changes();
echo '<br /><a target="_parent" href="'.url::method('configuration', 'index').'"><strong>Back to configuration start page.</strong></a>';
$page->html_end();
