/**
*	Loop through all elements of a form
*	Verify that all multiselect fields (right hand side)
*	are set to selected
*/
function loopElements(f) {
	// Specify which form fields (select) we are NOT interested in
	var nosave_suffix = "_tmp";

	if(!f || typeof f !== "object" || typeof f.elements === "undefined") {
		return;
	}

	for(i=0; i<f.elements.length; i++){
		if (f.elements[i].type=="select-multiple"){
			// set all options selected if we can't find
			//the nosave_suffix in element name
			if (f.elements[i].name.search(nosave_suffix)<0){
				for (a=0;a<f.elements[i].length;a++){
					f.elements[i].options[a].selected=true;
				}
			} else {
				// Unselect all other options
				for (a=0;a<f.elements[i].length;a++){
					f.elements[i].options[a].selected=false;
				}
			}
		}
	}
}

/**
*	Disable a form element, change the className and
*	display a new value
*	Primarily for use on submit buttons where return values
*	not needed for further processing (e.g. host_wizard).
*/
function setDisabled(theID, textStr)
{
	$("#" + theID).attr('disabled', true).addClass('button '+textStr);
	var theElement = document.getElementById(theID);
	theElement.value = textStr;
}

/**
*	cache the progress indicator image to show faster...
*/
var Image1 = new Image(16,16);
Image1.src = '/monitor/op5/nacoma/images/icons/indicator-white.gif';

/**
*	Show a progress indicator to inform user that something
*	is happening...
*/
function show_progress(the_id, info_str)
{
	var output = document.getElementById(the_id);
	if (output) {
		output.innerHTML	= '<br /><span style="vertical-align: top"><img id="progress_image_id" src="' + Image1.src + '" alt="" style="vertical-align: bottom" /> ' + info_str + '</span>';
		output.style.display = "block";
	}
}

/**
*	Enable a form element, change the className and
*	display a new value
*	Primarily for use on submit buttons where return values
*	not needed for further processing (e.g. host_wizard).
*/
function setEnabled(theID, textStr, value)
{
	var theElement = document.getElementById(theID);
	theElement.className = "button "+textStr;
	theElement.disabled = false;
	theElement.title = value;
	theElement.value = value;
}

/**
*	Remove whitespace from string
*/
function trim(str) {
	return str.replace(/^\s+|\s+$/g,"");
}
