<?php

define('SKIP_KOHANA', true);
require('/opt/monitor/op5/ninja/index.php');

if (PHP_SAPI === 'cli') {
	$console_access = true;
	require_once(dirname(__FILE__).'/include/config.inc.php');
	give_infinite_rights();
}
require_once(dirname(__FILE__).'/include/probe.inc.php');
require_once(dirname(__FILE__).'/include/system.inc.php');
require_once(dirname(__FILE__).'/include/autoscan.inc.php');

if (isset($argv[1])) {
	// SELECT id, count, epoch, criteria, name, description, enabled FROM autoscan_settings
	if (is_numeric($argv[1]) && is_int($argv[1] + 0) && $argv[1] >= 0) 
		$scan_list = autoscan_settings_get_by_id($argv[1]);
	elseif ($argv[1] == '*')
		$scan_list = autoscan_settings_get_list();
	else {
		fwrite(STDERR, 'Wrong argument (should be "*" or the id of a schedule)');
		exit(1);
	}
} else {
	fwrite(STDERR, 'Missing argument (should be "*" or the id of a schedule)');
	exit(1);
}

foreach($scan_list as $row) {
	$scan_enabled = $row[6];
	if (!$scan_enabled)
		continue;
	$scan_id = $row[0];
	$epoch = $row[2];
	$criteria = $row[3];

	if ($epoch == PHP_INT_MAX)
		$epoch = 0;
	else
		$epoch++;
	autoscan_settings_set_epoch($scan_id, $epoch);
	$target_list = ping_sweep($criteria);
	autoscan_settings_set_count($scan_id, 0);

	$new_host_count = 0;
	foreach ($target_list as $address => $name) {

		$host_id = autoscan_result_get_id($address);
		if ($host_id === false) {
			$host_id = autoscan_result_add($address, $name, 0, 1);
		} else {
			autoscan_result_set_name($host_id, $name);
		}

		if (autoscan_blacklist_and_monitor_check($address) === false) {
			$visibility = 1;
			$new_host_count++;
		} else {
			$visibility = 0;
		}

		$join_id = autoscan_join_get_id($scan_id, $host_id);
		if ($join_id === false) {
			autoscan_join_add($scan_id, $host_id, $epoch);
			autoscan_result_ref($host_id);
		} else {
			autoscan_join_set_epoch($join_id, $epoch);
		}

		autoscan_result_set_visibility($host_id, $visibility);
	}

	autoscan_settings_set_count($scan_id, $new_host_count, true);

	autoscan_result_unref_unused($scan_id, $epoch);
	autoscan_join_delete($scan_id, $epoch);
}

autoscan_result_delete_nonreferecned();

