<?php

/**
 * Host escalations are used to escalate notifications for a particular host.
 */
class hostescalation_nacoma_Model extends escalation_nacoma_Model
{
	/** object type */
	const TYPE = 'hostescalation';
	/** master object type */
	var $master_obj_type = 'host';
	var $master_obj_candidates = array('host' => 'host_name', 'hostgroup' => 'hostgroup_name');
	/** variable in this object identifying the master object */
	var $master_obj_identifier = 'host_name';

	public $properties = array (
		'topic' => NULL,
		'var_index' => array (
			'host_name' => 'select',
			'hostgroup_name' => 'select',
			'contacts' => 'mselect',
			'contact_groups' => 'mselect',
			'first_notification' => 'int',
			'last_notification' => 'int',
			'notification_interval' => 'int',
			'escalation_period' => 'select',
			'escalation_options' => 'checkbox',
			'register' => 'bool',
			'file_id' => 'select'
		),
		'widget' => array (
			'host_name' => 'hidden',
			'hostgroup_name' => 'hidden',
			'register' => 'hidden'
		),
		'default' => array (
			'escalation_options' => array (
				'd'
			),
			'file_id' => 'etc/hostescalations.cfg'
		),
		'required' => array (
			'host_name',
			'first_notification',
			'last_notification',
			'notification_interval',
			'file_id'
		),
		'req_alt' => array (
			'host_name' => 'hostgroup_name'
		),
		'special' => array (
			'host_name' => 'host',
			'hostgroup_name' => 'hostgroup',
			'contacts' => 'contact',
			'contact_groups' => 'contactgroup',
			'escalation_period' => 'timeperiod',
			'escalation_options' => array (
				'd' => 'Down',
				'u' => 'Unreachable',
				'r' => 'Recovery',
				'n' => false
			),
			'file_id' => 'FILE'
		)
	);

	/**
	 * Return the mayi resource for the object
	 * @see object_nacoma_Model::mayi_resource()
	 */
	public function mayi_resource() {
		return "monitor.monitoring.hostescalations";
	}

	function get_object_by_name($name)
	{
		$table = self::get_objects_for_user();
		$this->id = array_search($name, $table);
		return $this->get_object();
	}
}
